/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// ReportConfigurationScope Visibility scope for new report configurations
type ReportConfigurationScope string

// List of ReportConfigurationScope
const (
	GLOBAL ReportConfigurationScope = "global"
	ORGANIZATION ReportConfigurationScope = "organization"
	USER ReportConfigurationScope = "user"
)

// All allowed values of ReportConfigurationScope enum
var AllowedReportConfigurationScopeEnumValues = []ReportConfigurationScope{
	"global",
	"organization",
	"user",
}

func (v *ReportConfigurationScope) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ReportConfigurationScope(value)
	for _, existing := range AllowedReportConfigurationScopeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ReportConfigurationScope", value)
}

// NewReportConfigurationScopeFromValue returns a pointer to a valid ReportConfigurationScope
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewReportConfigurationScopeFromValue(v string) (*ReportConfigurationScope, error) {
	ev := ReportConfigurationScope(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ReportConfigurationScope: valid values are %v", v, AllowedReportConfigurationScopeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ReportConfigurationScope) IsValid() bool {
	for _, existing := range AllowedReportConfigurationScopeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ReportConfigurationScope value
func (v ReportConfigurationScope) Ptr() *ReportConfigurationScope {
	return &v
}

type NullableReportConfigurationScope struct {
	value *ReportConfigurationScope
	isSet bool
}

func (v NullableReportConfigurationScope) Get() *ReportConfigurationScope {
	return v.value
}

func (v *NullableReportConfigurationScope) Set(val *ReportConfigurationScope) {
	v.value = val
	v.isSet = true
}

func (v NullableReportConfigurationScope) IsSet() bool {
	return v.isSet
}

func (v *NullableReportConfigurationScope) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportConfigurationScope(val *ReportConfigurationScope) *NullableReportConfigurationScope {
	return &NullableReportConfigurationScope{value: val, isSet: true}
}

func (v NullableReportConfigurationScope) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportConfigurationScope) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

